unit graph24b;

interface

uses crt;

Var RT,GT,BT : Byte;
    OldBank : Word;

(*
   - 320X15BIT = $10D
   - 320X16BIT = $10E
   - 320X24BIT = $10F
   - 640X15BIT = $110
   - 640X16BIT = $111
   - 640X24BIT = $112
   - 800X15BIT = $113
   - 800X16BIT = $114
   - 800X24BIT = $115
*)

Procedure DetectUniVBE;
Procedure SetVESA24bit;
Procedure SetText;
Procedure PutPixel24(X,Y : Integer; R,G,B : Byte; Where : Word);
Procedure GetPixel24(X,Y : Integer; Where : Word);

implementation

Procedure DetectUniVBE;
Var Ver,Ver1 : Byte;
    VESASignature : Pointer;
    SegVESASignature,SegOEMStr,OfsOEMStr,TotalMemory : Word;
    OEMStr,S : String;
Begin
 GetMem(VESASignature,256+16);
 SegVESASignature:=Seg(VESASignature^)+1;
 SegOEMStr:=Seg(OEMStr[0]);
 OfsOEMStr:=Ofs(OEMStr[0]);
 Asm
  mov es,word ptr [SegVESASignature]
  xor di,di
  mov ax,$4f00
  int $10

  mov ax,[ES:DI+$12]
  shl ax,6                      { AX * 6 }
  mov word ptr [TotalMemory],ax

  mov ax,[es:di+$4]
  mov byte ptr [ver],ah
  mov byte ptr [ver1],al

  mov ax,word ptr [SegOEMStr]
  mov bx,word ptr [OfsOEMStr]
  mov dx,bx
  inc bx

  push ds
   lds si,[dword ptr ES:DI+$06]
   mov es,ax
   mov di,bx
   xor cx,cx
 @@Loop:
    lodsb
    stosb
    inc cx
    cmp al,0
    jne @@Loop

    mov di,dx
    mov [ES:DI],cl
  pop ds
 End;
 ClrScr;
 TextColor(7);
 TextBackGround(0);
 Writeln('VESA on this hardware  : ',OEMStr);
 Writeln('VESA Version           : ',Ver,'.',Ver1);
 Writeln('VESA video memory size : ',TotalMemory,'K');
 S:=Copy(OEMStr,1,9);
 If S = 'Universal' Then Begin
  Writeln('UniVBE                 : installed');
  readkey;
  ClrScr;
 End Else Begin
  Writeln('UniVBE                 : NOT installed ');
  TextColor(15);
  Writeln;
  Writeln('Please install your UniVBE driver.');
  Writeln('Program halted');
  Writeln('Press any key to continue');
  Readkey;
  TextColor(7);
  Halt(1);
 End;
 FreeMem(VESASignature,256+16);
End;

Procedure SetVESA24bit; Assembler;
{ Use with UniVBE ONLY }
{ This procedure sets VESA mode 112h 640x480x16M (24_bit) }
Asm
  mov ax,$4f02
  mov bx,$112
  int $10
End;

Procedure SetText; Assembler;
Asm
  mov ax,3h
  int $10
End;

Procedure PutPixel24(X,Y : Integer; R,G,B : Byte; Where : Word); Assembler;
{ Use with UniVBE ONLY; mode 112h 640x480x16M (24_bit) }
{ Granularity MUST be 64K }
Asm
 mov ax,word ptr [Y]
 mov cx,2048            { <--- Bytes Per Line }
 imul cx

 mov bx,word ptr [X]
 mov cx,bx
 shl bx,1
 add bx,cx

 add ax,bx
 adc ax,0
 mov di,ax
 cmp word ptr [OldBank],dx
 je @@PutThePixel
  mov word ptr [OldBank],dx
  xor bx,bx
  mov ax,$4f05
  int $10

@@PutThePixel:
 mov es,word ptr [Where]
 mov al,byte ptr [B]
 stosb
 mov al,byte ptr [G]
 stosb
 mov al,byte ptr [R]
 stosb
End;

Procedure GetPixel24(X,Y : Integer; Where : Word); Assembler;
{ Use with UniVBE ONLY; mode 112h 640x480x16M (24_bit) }
{ Granularity MUST be 64K }
Asm
 mov ax,word ptr [Y]
 mov cx,2048            { <--- Bytes Per Line }
 imul cx

 mov bx,word ptr [X]
 mov cx,bx
 shl bx,1
 add bx,cx

 add ax,bx
 adc ax,0
 mov di,ax
 cmp word ptr [OldBank],dx
 je @@GetThePixel
  mov word ptr [OldBank],dx
  xor bx,bx
  mov ax,$4f05
  int $10

@@GetThePixel:
 mov es,word ptr [Where]
 mov al,[ES:DI]
 mov byte ptr [BT],al
 mov al,[ES:DI+1]
 mov byte ptr [GT],al
 mov al,[ES:DI+2]
 mov byte ptr [RT],al
End;

begin
end.
