UNIT VgaGrp;


INTERFACE


Const VGA=$A000;

Var SinT,CosT : Array[0..359] Of Integer;
    Period : Real;

{ Init and close VGA }
Procedure SetVGA;
Procedure SetText;
{ Color procedures }
Procedure GetRGB(Col : Byte; var R,G,B : Byte);
Procedure SetRGB(Col, R,G,B : Byte);
Procedure SetR_G_B(Col : Byte; C : Char; RGB : Byte);
Function  GetR_G_B(Col : Byte; C : Char) : Byte;
{ Screen (VGA,virtual) procedures }
Procedure ClearFake(VideoSeg : Word);
Procedure ClearFakeColor(Col : Byte; VideoSeg : Word);
Procedure ShowFake(FromSeg : Word);
Procedure CopyFake(FromSeg,ToSeg : Word);
Procedure VRet;
{ Draw procedures }
Procedure PutPixel(X,Y : Integer; Col : Byte; Where : Word);
Function GetPixel(X,Y : Integer; Where : Word) : Byte;
Procedure HLine(X,Y,X1 : Integer; Col : Byte; Where : Word);
Procedure VLine(X,Y,Y1 : Integer; Col : Byte; Where : Word);
Procedure Box(X,Y,X1,Y1 : Integer; Col : Byte; Where : Word);
Procedure Line(X,Y,X1,Y1 : Integer; Color : Byte; Where : Word);
{ Perspective }
Function p3d(xy,z:LongInt):longint;
{ Initialize Sinus and Cosinus }
Procedure InitSinCos(MulFactor : Word);


IMPLEMENTATION


Procedure SetVGA; Assembler;
Asm
 mov ax,13h
 int 10h
End; { SetVGA }

Procedure SetText; Assembler;
Asm
 mov ax,3h
 int 10h
End; { SetText }

Procedure PutPixel(X,Y:Integer; Col:Byte; Where:Word); Assembler;
Asm
 mov es,word ptr [Where]
 mov di,word ptr [X]
 mov bx,word ptr [Y]
 cmp di,319
 ja @@EXIT
 cmp bx,199
 ja @@EXIT
  mov ax,bx
  shl bx,8
  shl ax,6
  add bx,ax
  add di,bx
  mov al,byte ptr [Col]
  stosb
@@EXIT:
End; { PutPixel }

Function GetPixel(X,Y:Integer; Where:Word) : Byte; Assembler;
Asm
 xor al,al
 mov es,word ptr [Where]
 mov di,word ptr [X]
 mov bx,word ptr [Y]
 cmp di,319
 ja @@EXIT
 cmp bx,199
 ja @@EXIT
  mov ax,bx
  shl bx,8
  shl ax,6
  add bx,ax
  add di,bx
  mov al,[ES:DI]
@@EXIT:
End; { GetPixel }

Procedure HLine(X,Y,X1 : Integer; Col : Byte; Where : Word); Assembler;
Asm
 mov es,word ptr [Where]
 mov dx,word ptr [X]
 mov cx,word ptr [X1]
 cmp dx,cx { cmp X,X1 }
 jg @@DXviacCX    { @@XviacX1 }
  { (X1 > X)|(CX > DX) }
  cmp cx,0
  jnl @@Go1
   mov cx,0
   cmp dx,0
   jl @@EXIT
  @@Go1:
  cmp cx,319
  jng @@Go2
   mov cx,319
   cmp dx,319
   jg @@EXIT

  @@Go2:
  cmp dx,0
  jnl @@Go3
   mov dx,0
   cmp cx,0
   jl @@EXIT
  @@Go3:
  cmp dx,319
  jng @@Go4
   mov dx,319
   cmp cx,319
   jg @@EXIT

  @@Go4:
  sub cx,dx
  jmp @@Yvalue

@@DXviacCX:
  { (X > X1)|(DX > CX) }
  cmp cx,0
  jnl @@Go11
   mov cx,0
   cmp dx,0
   jl @@EXIT
  @@Go11:
  cmp cx,319
  jng @@Go21
   mov cx,319
   cmp dx,319
   jg @@EXIT

  @@Go21:
  cmp dx,0
  jnl @@Go31
   mov dx,0
   cmp cx,0
   jl @@EXIT
  @@Go31:
  cmp dx,319
  jng @@Go41
   mov dx,319
   cmp cx,319
   jg @@EXIT

  @@Go41:
  xchg cx,dx
  sub cx,dx

@@Yvalue:
 mov bx,word ptr [Y]
 cmp bx,0
 jl @@EXIT
 cmp bx,199
 jg @@EXIT

 mov di,dx
 mov ax,bx
 shl bx,8
 shl ax,6
 add di,ax
 add di,bx

 inc cx
 mov si,cx
 add si,di
 shr cx,2

 mov al,byte ptr [Col]
 mov ah,al
 mov bx,ax
 db $66; shl ax,16
 mov ax,bx
 db $66; rep stosw

 sub si,di
 mov cx,si
 rep stosb
@@EXIT:
End; { HLine }

Procedure VLine(X,Y,Y1 : Integer; Col : Byte; Where : Word); Assembler;
Asm
 mov es,word ptr [Where]
 mov dx,word ptr [Y]
 mov cx,word ptr [Y1]
 cmp dx,cx { cmp Y,Y1 }
 jg @@DXviacCX    { @@YviacY1 }
  { (Y1 > Y)|(CX > DX) }
  cmp cx,0
  jnl @@Go1
   mov cx,0
   cmp dx,0
   jl @@EXIT
  @@Go1:
  cmp cx,199
  jng @@Go2
   mov cx,199
   cmp dx,199
   jg @@EXIT

  @@Go2:
  cmp dx,0
  jnl @@Go3
   mov dx,0
   cmp cx,0
   jl @@EXIT
  @@Go3:
  cmp dx,199
  jng @@Go4
   mov dx,199
   cmp cx,199
   jg @@EXIT

  @@Go4:
  sub cx,dx
  jmp @@Xvalue

@@DXviacCX:
  { (Y > Y1)|(DX > CX) }
  cmp cx,0
  jnl @@Go11
   mov cx,0
   cmp dx,0
   jl @@EXIT
  @@Go11:
  cmp cx,199
  jng @@Go21
   mov cx,199
   cmp dx,199
   jg @@EXIT

  @@Go21:
  cmp dx,0
  jnl @@Go31
   mov dx,0
   cmp cx,0
   jl @@EXIT
  @@Go31:
  cmp dx,199
  jng @@Go41
   mov dx,199
   cmp cx,199
   jg @@EXIT

  @@Go41:
  xchg cx,dx
  sub cx,dx

@@Xvalue:
 mov di,word ptr [X]
 cmp di,0
 jl @@EXIT
 cmp di,319
 jg @@EXIT

 mov ax,dx
 shl dx,8
 shl ax,6
 add di,ax
 add di,dx

 mov al,byte ptr [Col]

 inc cx
 @@Loop:
  mov [ES:DI],al
  add di,320
  dec cx
  jnz @@Loop
@@EXIT:
End; { VLine }

Procedure Box(X,Y,X1,Y1 : Integer; Col : Byte; Where : Word); Assembler;
Asm
 mov ax,word ptr [X]
 mov cx,word ptr [X1]
 cmp ax,cx { cmp X,X1 }
 jg @@AXviacCX    { @@XviacX1 }
  { (X1 > X)|(CX > AX) }
  cmp cx,0
  jnl @@Go1
   mov cx,0
   cmp ax,0
   jl @@EXIT
  @@Go1:
  cmp cx,319
  jng @@Go2
   mov cx,319
   cmp ax,319
   jg @@EXIT

  @@Go2:
  cmp ax,0
  jnl @@Go3
   mov ax,0
   cmp cx,0
   jl @@EXIT
  @@Go3:
  cmp ax,319
  jng @@Go4
   mov ax,319
   cmp cx,319
   jl @@EXIT

  @@Go4:
  sub cx,ax
  jmp @@Yvalue

@@AXviacCX:
  { (X > X1)|(AX > CX) }
  cmp cx,0
  jnl @@Go11
   mov cx,0
   cmp ax,0
   jl @@EXIT
  @@Go11:
  cmp cx,319
  jng @@Go21
   mov cx,319
   cmp ax,319
   jg @@EXIT

  @@Go21:
  cmp ax,0
  jnl @@Go31
   mov ax,0
   cmp cx,0
   jl @@EXIT
  @@Go31:
  cmp ax,319
  jng @@Go41
   mov ax,319
   cmp cx,319
   jg @@EXIT

  @@Go41:
  xchg cx,ax
  sub cx,ax

@@Yvalue:

{ --- AX = X-ova suradnica; CX - DeltaX --- }
 mov bx,word ptr [Y]
 mov dx,word ptr [Y1]
 cmp bx,dx { cmp Y,Y1 }
 jg @@BXviacDX    { @@YviacY1 }
  { (Y1 > Y)|(DX > BX) }
  cmp dx,0
  jnl @@Go12
   mov dx,0
   cmp bx,0
   jl @@EXIT

  @@Go12:
  cmp dx,199
  jng @@Go22
   mov dx,199
   cmp bx,199
   jg @@EXIT

  @@Go22:
  cmp bx,0
  jnl @@Go32
   mov bx,0
   cmp dx,0
   jl @@EXIT
  @@Go32:
  cmp bx,199
  jng @@Go42
   mov bx,199
   cmp dx,199
   jg @@EXIT

  @@Go42:
  sub dx,bx
  jmp @@VgaOfs

@@BXviacDX:
  { (Y > Y1)|(DX > CX) }
  cmp dx,0
  jnl @@Go13
   mov dx,0
   cmp bx,0
   jl @@EXIT
  @@Go13:
  cmp dx,199
  jng @@Go23
   mov dx,199
   cmp bx,199
   jg @@EXIT

  @@Go23:
  cmp bx,0
  jnl @@Go33
   mov bx,0
   cmp dx,0
   jl @@EXIT
  @@Go33:
  cmp bx,199
  jng @@Go43
   mov bx,199
   cmp dx,199
   jg @@EXIT

  @@Go43:
  xchg dx,bx
  sub dx,bx

@@VgaOfs:
{ --- BX = Y-ova suradnica; DX - DeltaY --- }
  inc cx
  inc dx
  mov es,word ptr [Where]
  mov di,ax
  mov ax,bx
  shl ax,8
  shl bx,6
  add di,ax
  add di,bx

  mov bx,cx
  mov al,byte ptr [Col]

 @@LoopY:
   mov cx,bx
   rep stosb
   add di,320
   sub di,bx
   dec dx
   jnz @@LoopY
@@EXIT:
End; { Box }

Procedure ClearFake(VideoSeg : Word); Assembler;
Asm
 mov es,word ptr [VideoSeg]
 xor di,di
 mov cx,16000
 db $66; xor ax,ax
 cld
 db $66; rep stosw
End; { ClearFake }

Procedure CopyFake(FromSeg,ToSeg : Word); Assembler;
Asm
 push ds
 mov es,word ptr [ToSeg]
 mov ds,word ptr [FromSeg]
 xor di,di
 xor si,si
 mov cx,16000
 cld
 db $66; rep movsw
 pop ds
End; { CopyFake }

Procedure ClearFakeColor(Col : Byte; VideoSeg : Word); Assembler;
Asm
 mov es,word ptr [VideoSeg]
 xor di,di
 mov cx,16000
 db $66; xor ax,ax
 mov al,byte ptr [Col]
 mov ah,al
 mov bx,ax
 db $66; shl ax,16
 mov ax,bx
 cld
 db $66; rep stosw
End; { ClearFakeColor }


Procedure ShowFake(FromSeg : Word); Assembler;
Asm
 push ds
 mov ax,$A000
 mov es,ax
 mov ds,word ptr [FromSeg]
 xor di,di
 xor si,si
 mov cx,16000
 cld
 db $66; rep movsw
 pop ds
End; { ShowFake }

Procedure VRet; Assembler;
Asm
 mov dx,$3da
@@1:
 in al,dx
 test al,$08
 jnz @@1
@@2:
 in al,dx
 test al,$08
 jz @@2
End; { VRet }

Procedure SetRGB(Col,R,G,B : Byte); Assembler;
Asm
 mov dx,$3c8
 mov al,byte ptr [Col]
 out dx,al

 mov dx,$3c9

 mov al,byte ptr [R]
 out dx,al
 mov al,byte ptr [G]
 out dx,al
 mov al,byte ptr [B]
 out dx,al
End; { SetRGB }

Procedure GetRGB(Col : Byte; Var R,G,B : Byte);
Var Ri,Gi,Bi : Byte;
Begin
 Asm
  mov dx,$3c7
  mov al,byte ptr [Col]
  out dx,al

  mov dx,$3c9

  in al,dx
  mov byte ptr [Ri],al
  in al,dx
  mov byte ptr [Gi],al
  in al,dx
  mov byte ptr [Bi],al
 End;
 R:=Ri; G:=Gi; B:=Bi;
End; { GetRGB }

Procedure SetR_G_B(Col : Byte; C : Char; RGB : Byte); Assembler;
Var R,G,B : Byte;
Asm
 mov dx,$3c7
 mov al,byte ptr [Col]
 out dx,al

 mov dx,$3c9

 in al,dx
 mov byte ptr [R],al
 in al,dx
 mov byte ptr [G],al
 in al,dx
 mov byte ptr [B],al

 mov dx,$3c8
 mov al,byte ptr [Col]
 out dx,al

 mov dx,$3c9

 mov bl,byte ptr [C]

 cmp bl,82
 jne @@Next_r1
  mov al,byte ptr [RGB]
  out dx,al
  mov al,byte ptr [G]
  out dx,al
  mov al,byte ptr [B]
  out dx,al
  jmp @@EXIT
@@Next_r1:
 cmp bl,114
 jne @@Next_G
  mov al,byte ptr [RGB]
  out dx,al
  mov al,byte ptr [G]
  out dx,al
  mov al,byte ptr [B]
  out dx,al
  jmp @@EXIT
@@Next_G:
 cmp bl,71
 jne @@Next_g1
  mov al,byte ptr [R]
  out dx,al
  mov al,byte ptr [RGB]
  out dx,al
  mov al,byte ptr [B]
  out dx,al
  jmp @@EXIT
@@Next_g1:
 cmp bl,103
 jne @@Next_B
  mov al,byte ptr [R]
  out dx,al
  mov al,byte ptr [RGB]
  out dx,al
  mov al,byte ptr [B]
  out dx,al
  jmp @@EXIT
@@Next_B:
 cmp bl,66
 jne @@Next_b1
  mov al,byte ptr [R]
  out dx,al
  mov al,byte ptr [G]
  out dx,al
  mov al,byte ptr [RGB]
  out dx,al
  jmp @@EXIT
@@Next_b1:
 cmp bl,98
 jne @@EXIT
  mov al,byte ptr [R]
  out dx,al
  mov al,byte ptr [G]
  out dx,al
  mov al,byte ptr [RGB]
  out dx,al

@@EXIT:
End;

Function GetR_G_B(Col : Byte; C : Char) : Byte; Assembler;
Var R,G,B : Byte;
Asm
 mov dx,$3c7
 mov al,byte ptr [Col]
 out dx,al

 mov dx,$3c9

 in al,dx
 mov byte ptr [R],al
 in al,dx
 mov byte ptr [G],al
 in al,dx
 mov byte ptr [B],al

 mov bl,byte ptr [C]

 cmp bl,82
 jne @@Next_r1
  mov al,byte ptr [R]
  jmp @@EXIT
@@Next_r1:
 cmp bl,114
 jne @@Next_G
  mov al,byte ptr [R]
  jmp @@EXIT
@@Next_G:
 cmp bl,71
 jne @@Next_g1
  mov al,byte ptr [G]
  jmp @@EXIT
@@Next_g1:
 cmp bl,103
 jne @@Next_B
  mov al,byte ptr [G]
  jmp @@EXIT
@@Next_B:
 cmp bl,66
 jne @@Next_b1
  mov al,byte ptr [B]
  jmp @@EXIT
@@Next_b1:
 cmp bl,98
 jne @@EXIT
  mov al,byte ptr [B]

@@EXIT:
End; { GetR_G_B }

{Function P3D1(XY,Z : LongInt) : LongInt;
Begin
 P3D1:= 256 * XY Div Z;
End;}

Function P3D(XY,Z : LongInt) : LongInt; Assembler;
{ Using formula " ( 256*XY ) Div Z " }
Asm
 db $66; mov ax,word ptr [XY]
 db $66; xor bx,bx
 db $66; mov cx,word ptr [Z]
 mov bx,256
 db $66; imul bx
 db $66; idiv cx
 db $66; mov dx,ax
 db $66; shr dx,16
End;

Procedure Line(X,Y,X1,Y1 : Integer; Color : Byte; Where : Word); Assembler;
{ Chybna procedura, a este aj pomala }
Asm
 mov es,[where]
 mov ax,[x]
 mov bx,[y]
 mov di,ax
 mov ax,bx
 shl bx,8
 shl ax,6
 add bx,ax
 add di,bx

 mov al,Color
 mov si,0

 mov cx,X1
 mov dx,X
 cmp cx,dx
 jg @@2
 je @@e
  mov cx,Y1
  mov dx,Y
  cmp cx,dx
  jg @@D_L
  jmp @@U_L
@@2:
  mov cx,Y1
  mov dx,Y
  cmp cx,dx
  jg @@D_R
   jmp @@U_R

@@e:
  mov cx,Y1
  mov dx,Y
  cmp cx,dx
  jg @@D
  je @@plot
  jmp @@U

@@plot:
  mov [es:di],al
  jmp @@EXIT

@@D_R:
 mov dx,X1
 sub dx,X
 mov bx,Y1
 sub bx,Y

 mov cx,dx
 dec di
 @@Xloop1:
   add si,bx
   inc di                {X := X + 1}
  @@Yloop1:
    sub si,dx
    jbe @@Continue1
    mov [es:di],al
    add di,320           {Y := Y + 1}
    jmp @@Yloop1

  @@Continue1:
   add si,dx
   mov [es:di],al
   dec cx
   jnz @@Xloop1
   jmp @@EXIT

@@D_L:
 mov dx,X
 sub dx,X1
 mov bx,Y1
 sub bx,Y

 mov cx,dx
 inc di
 @@Xloop2:
   add si,bx
   dec di                {X := X - 1}
  @@Yloop2:
    sub si,dx
    jbe @@Continue2
    mov [es:di],al
    add di,320           {Y := Y + 1}
    jmp @@Yloop2

  @@Continue2:
   add si,dx
   mov [es:di],al
   dec cx
   jnz @@Xloop2
   jmp @@EXIT

@@U_L:
 mov dx,X
 sub dx,X1
 mov bx,Y
 sub bx,Y1

 mov cx,dx
 inc di
 @@Xloop3:
   add si,bx
   dec di                {X := X - 1}
  @@Yloop3:
    sub si,dx
    jbe @@Continue3
    mov [es:di],al
    sub di,320           {Y := Y - 1}
    jmp @@Yloop3

  @@Continue3:
   add si,dx
   mov [es:di],al
   dec cx
   jnz @@Xloop3
   jmp @@EXIT

@@U_R:
 mov dx,X1
 sub dx,X
 mov bx,Y
 sub bx,Y1

 mov cx,dx
 dec di
 @@Xloop4:
   add si,bx
   inc di                {X := X + 1}
  @@Yloop4:
    sub si,dx
    jbe @@Continue4
    sub di,320           {Y := Y - 1}
    mov [es:di],al
    jmp @@Yloop4

  @@Continue4:
   add si,dx
   mov [es:di],al
   dec cx
   jnz @@Xloop4
   jmp @@EXIT

@@U:
 mov bx,Y
 sub bx,Y1

 mov cx,bx

 @@Yloop5:
   mov [es:di],al
   sub di,320
   dec cx
   jnz @@Yloop5
   jmp @@EXIT

@@D:
 mov bx,Y1
 sub bx,Y

 mov cx,bx

 @@Yloop6:
   mov [es:di],al
   add di,320
   dec cx
   jnz @@Yloop6

@@EXIT:
End;

Procedure InitSinCos(MulFactor : Word);
{ Maximum of MulFactor is 32766 }
Var I : Integer;
Begin
 Period:=PI / 180;
 For I:=0 To 359 Do Begin
  SinT[I]:=Round(Sin(I*Period)*MulFactor);
  CosT[I]:=Round(Cos(I*Period)*MulFactor);
 End;
End;

END.