{ This program shows the usage of the AsmRotate32, MovePoints32,
  AddPerspective32, QSort32 and the gourad-shading tetragon procedures }

Program Example3;

Uses
	Crt,XVGA;
{ CRT is linked because of the KeyPressed function }

Const
	stpoints	: Array[1..72] Of integer = (
		-10, -5, 0,
		 -5, -5, 0,
		  5, -5, 0,
		 10, -5, 0,
		 -5,  0, 0,
		  0,  0, 0,
		  5,  0, 0,
                  0,  5, 0,
		-10, 10, 0,
                 -5, 10, 0,
                  5, 10, 0,
                  10,10, 0,
                  -10, -5, 10,
		 -5, -5, 10,
		  5, -5, 10,
		 10, -5, 10,
		 -5,  0, 10,
		  0,  0, 10,
		  5,  0, 10,
                  0,  5, 10,
		-10, 10, 10,
                 -5, 10, 10,
                  5, 10, 10,
                  10,10, 10);

	Faces		: Array[1..40] Of TPoint32 = (	{ Uses TPoint32 because
												  three values for faces }
{1.side}	(9,10,1),(2,10,1),(6,5,2),(5,6,8),
                (7,6,3),(6,7,8),(3,4,11),(4,12,11),
{2.side}        (13,21,22),(13,14,22),(14,17,18),(17,18,20),
                (18,19,15),(20,18,19),(23,15,16),(16,23,24),
{z}             (11,12,23),(23,24,12),(9,10,21),(21,22,10),
                (11,19,7),(11,23,19),(10,17,22),(5,10,17),
                (17,20,8),(5,8,17),(19,20,8),(7,19,8),
                (12,24,16),(16,12,4),(9,21,13),(13,9,1),
                (1,2,13),(13,14,2),(3,4,15),(15,16,4),
                (14,18,6),(2,6,14),(15,18,6),(3,6,15)
	);
	{ Object definition, a cube }

Var
	Index   	: Word;
	FaceIndex	: Word;
	AngleX,a,b,c	: Integer;
	AngleY		: Integer;
	AngleZ		: Integer;

        Points          : array[1..24] of tpoint32;
	CPoints		: Array[1..24] Of TPoint32;
	{ Temporary storage for rotated points }
	FaceList	: Array[1..high(faces)] Of TSortRec32;

	FakePtr		: Pointer;
	FakeSeg		: Word;
	{ Variables for the "fake" screen }

	X1,Y1,Z1	: Integer;
	X2,Y2,Z2	: Integer;
	X3,Y3,Z3	: Integer;
	C1,C2,C3	: Integer;

Begin
        c:=1;
        for a:=1 to 24 do begin
        for b:=1 to 3 do begin
        points[a,b]:=4*stpoints[c];c:=c+1;
        end;end;
	XMode(TRUE);
	{ Switch to graphics mode }

	For Index:=0 To 64 Do
		XSetRGB(Index,index,round(index/4),round(index/4));
	{ Set the first 64 colors to a gradual shade from black to white }

	GetMem(FakePtr,64016);
	{ Allocate 64016 bytes for the "fake" screen. The reason for the
	  extra 16 bytes (320*200 = 64000) is that pascal may align the
	  memory block on the offsets 0 or 8. By allocating 16 extra bytes,
	  we can just skip the first segment (16 or 8 bytes) and use the
	  next 64000 bytes without problems }
	FakeSeg:=Seg(FakePtr^)+1;
	{ Create the segment reference }

	AngleX:=0;
	AngleY:=0;
	AngleZ:=0;
	InitSinCos(10);
	{ Prepare the lookup tables with 1024 (2^10) sin and cos values }
        c:=200;a:=0;b:=3;
	Repeat

       { if points[1,1]<0 then begin;        inc(points[1,1]);
                inc(points[1,3]);
                dec(points[2,1]);
                inc(points[2,3]);
                inc(points[5,1]);
                dec(points[5,3]);
                dec(points[6,1]);
                dec(points[6,3]);end;   }
		ClearFake(FakeSeg);
		{ Clear the "fake" screen }

		AsmRotate32(Points,CPoints,High(Points),AngleX,AngleY,AngleZ);
		{ Rotate the object }
		AddPerspective32(CPoints,High(Points),8,c);
		{ Apply perspective }
		MovePoints32(CPoints,High(Points),160,100,0);
		{ Move object to center of screen }

		For Index:=1 To High(Faces) Do Begin
			FaceList[Index].ID:=Index;
			FaceList[Index].SortValue:=
				CPoints[Faces[Index,1],3]+
				CPoints[Faces[Index,2],3]+
				CPoints[Faces[Index,3],3];
			{ Calculate the center z-value of the face by adding all the
			  z-values of the corners of the face. To get the true
			  middle point, I would have to divide by 3, but if I scale all
			  values up by 3, I can drop the DIV 3 for all the faces and
			  speed up the calculations }
		End;

		QSort32(FaceList,High(Faces));
		{ Sort the faces depth-first }

		For Index:=1 To High(Faces) Do Begin
			FaceIndex:=FaceList[Index].ID;
			{ Get index of face to draw }

			X1:=CPoints[Faces[FaceIndex,1],1];
			Y1:=CPoints[Faces[FaceIndex,1],2];
			Z1:=CPoints[Faces[FaceIndex,1],3];
			{ Coordinates for first corner }

			X2:=CPoints[Faces[FaceIndex,2],1];
			Y2:=CPoints[Faces[FaceIndex,2],2];
			Z2:=CPoints[Faces[FaceIndex,2],3];
			{ Coordinates for second corner }

			X3:=CPoints[Faces[FaceIndex,3],1];
			Y3:=CPoints[Faces[FaceIndex,3],2];
			Z3:=CPoints[Faces[FaceIndex,3],3];
			{ Coordinates for third corner }

			If Visible(X1,Y1,X2,Y2,X3,Y3)<>0 Then Begin
			{ Determine if face is visible }
				C1:=28-(Z1 Div 2);
				C2:=28-(Z2 Div 2);
				C3:=28-(Z3 Div 2);
				{ Calculate the corner colors by using the depth-values (z) as
				  bases }

				XTetraGourad(X1,Y1,C1,X2,Y2,C2,X3,Y3,C3,FakeSeg);

				{ Draw the gourad-shaded face }
			End;
		End;

		VRet;
		{ Wait for vertical retrace }

		ShowFake(FakeSeg);
		{ Copy the "fake" screen to the visible screen }

if b=0 then		AngleX:=(AngleX+6) And TableMask;
if b=1 then		AngleY:=(AngleY+6) And TableMask;
if b=2 then		AngleZ:=(AngleZ+6) And TableMask;
if b=3 then     begin;  anglex:=(anglex+2) and tablemask;
                        angley:=(angley+2) and tablemask;
                        anglez:=(anglez+2) and tablemask;  end;
		{ Adjust the angles, so as to rotate the object }
if b=4 then begin;delay(100);xmode(false);clrscr;textcolor(28);
            writeln('-M- EfFeCt By MaRtIn SiMeCeK 1.11.1999');
            delay(100);textcolor(white);exit;end;
	Until KeyPressed;
	{ Loop until a key is pressed }

	XMode(FALSE);
	{ Switch back to text-mode }
End.
